package de.uni_marburg.powersort.benchmark;

import org.junit.jupiter.api.Test;

import static org.junit.jupiter.api.Assertions.*;

class LongFormatterTest {
    @Test
    void negDigit4() {
        assertEquals("-1_234", LongFormatter.formatUnderscore(-1234));
    }
    @Test
    void negDigit3() {
        assertEquals("-123", LongFormatter.formatUnderscore(-123));
    }
    @Test
    void negDigit2() {
        assertEquals("-12", LongFormatter.formatUnderscore(-12));
    }
    @Test
    void negDigit1() {
        assertEquals("-1", LongFormatter.formatUnderscore(-1));
    }
    @Test
    void digit1() {
        assertEquals("0", LongFormatter.formatUnderscore(0));
    }

    @Test
    void digit2() {
        assertEquals("12", LongFormatter.formatUnderscore(12));
    }

    @Test
    void digit3() {
        assertEquals("123", LongFormatter.formatUnderscore(123));
    }

    @Test
    void digit4() {
        assertEquals("1_234", LongFormatter.formatUnderscore(1234));
    }

    @Test
    void digit5() {
        assertEquals("12_345", LongFormatter.formatUnderscore(12345));
    }

    @Test
    void digit6() {
        assertEquals("123_456", LongFormatter.formatUnderscore(123456));
    }
    @Test
    void digit7() {
        assertEquals("1_234_567", LongFormatter.formatUnderscore(1234567));
    }
}
